'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vuex = require('vuex');
var vueClassComponent = require('vue-class-component');

function State(value) {
    const arr = value.split("/");
    return function (target, propertyKey) {
        vueClassComponent.createDecorator(function (options, key) {
            options.computed[key] = () => {
                let data = vuex.useStore().state;
                arr.forEach((item) => {
                    data = data[item];
                });
                return data;
            };
        })(target, propertyKey);
    };
}
function Action(value) {
    return function (target, propertyKey) {
        vueClassComponent.createDecorator(function (options, key) {
            options.methods[key] = function (...args) {
                return vuex.useStore().dispatch(value, ...args);
            };
        })(target, propertyKey);
    };
}
function Getter(value) {
    return function (target, propertyKey) {
        vueClassComponent.createDecorator(function (options, key) {
            options.methods[key] = () => {
                return vuex.useStore().getters(value);
            };
        })(target, propertyKey);
    };
}
function Mutation(value) {
    return function (target, propertyKey) {
        vueClassComponent.createDecorator(function (options, key) {
            options.methods[key] = function (...args) {
                return vuex.useStore().commit(value, ...args);
            };
        })(target, propertyKey);
    };
}
var index = {
    State,
    Action,
    Getter,
    Mutation
};

exports.Action = Action;
exports.Getter = Getter;
exports.Mutation = Mutation;
exports.State = State;
exports.default = index;
