import { useStore } from 'vuex';
import { createDecorator } from 'vue-class-component';

function State(value) {
    const arr = value.split("/");
    return function (target, propertyKey) {
        createDecorator(function (options, key) {
            options.computed[key] = () => {
                let data = useStore().state;
                arr.forEach((item) => {
                    data = data[item];
                });
                return data;
            };
        })(target, propertyKey);
    };
}
function Action(value) {
    return function (target, propertyKey) {
        createDecorator(function (options, key) {
            options.methods[key] = function (...args) {
                return useStore().dispatch(value, ...args);
            };
        })(target, propertyKey);
    };
}
function Getter(value) {
    return function (target, propertyKey) {
        createDecorator(function (options, key) {
            options.methods[key] = () => {
                return useStore().getters(value);
            };
        })(target, propertyKey);
    };
}
function Mutation(value) {
    return function (target, propertyKey) {
        createDecorator(function (options, key) {
            options.methods[key] = function (...args) {
                return useStore().commit(value, ...args);
            };
        })(target, propertyKey);
    };
}
var index = {
    State,
    Action,
    Getter,
    Mutation
};

export default index;
export { Action, Getter, Mutation, State };
